var _ = require('lodash');
var AWS = require('./AWS').AWS;
var AWSCognito = require('./AWS').AWSCognito;


function CognitoIdentitySDK(config) {
    this.identityPoolInfo = config    
}

function getCredentialsConfig(session) {
    const { IdentityPoolId, LoginKey, region } = this.identityPoolInfo
    const logins = {}
    logins[LoginKey] = session.getIdToken().getJwtToken();
    
    return {
        IdentityPoolId,
        Logins: logins
    }
}

function getCredentials(session) {
    const { IdentityPoolId, LoginKey, region } = this.identityPoolInfo
    const logins = {}
    logins[LoginKey] = session.getIdToken().getJwtToken();

    const credentials = new AWS.CognitoIdentityCredentials({
        IdentityPoolId,
        Logins: logins
    },{
        region
    });
    
    return credentials;
}

function getIdentityForUserSession(session) {
    return new Promise((resolve, rejecet) => {
        getCredentials(session).refresh((err) => {
            if (err) {
                console.error(err);
                reject(err);
                return;
            }
            else {
                console.log('credentials success');
                resolve()
            }
        })
    });
    
}

CognitoIdentitySDK.prototype = {
    getCredentials,
    getIdentityForUserSession
}

module.exports = CognitoIdentitySDK;

